=== debian/changelog ===
vienna-rna (2.5.1+dfsg-1build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:24:05 +1100

vienna-rna (2.5.1+dfsg-1build2) noble; urgency=medium

  * No-change rebuild against libdlib19.1t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 19 Mar 2024 02:47:09 +0000

vienna-rna (2.5.1+dfsg-1build1) noble; urgency=medium

  * No-change rebuild with Python 3.12 as default

 -- Graham Inggs <ginggs@ubuntu.com>  Sat, 20 Jan 2024 09:19:10 +0000

vienna-rna (2.5.1+dfsg-1) unstable; urgency=medium

  [ Andreas Tille ]
  * Team upload.
  * New upstream version
  * Point watch file to github
  * Standards-Version: 4.6.2 (routine-update)
  * Update lintian override info format in d/vienna-rna.lintian-overrides on
    line 5-7.
  * DEP3
  * Build-Depends: libdlib-dev
  * Use Debian packaged dlib
  * Fix module name for autopkgtest-pkg-python

  [ Étienne Mollier ]
  * d/control: build depends on liblapack-dev.
  * use_debian_packaged_dlib.patch: link bin/ components against lapack.
  * use_debian_packaged_dlib.patch: link also Perl modules.
  * use_debian_packaged_dlib.patch: link also Python 3 module.
  * d/rules: ventilate dh_auto_configure target.
  * d/rules: upstream assumes --with-python is for python3 now.
  * python3.11.patch: restore in the d/t/series.
  * python3.11.patch: hardcode .so extension.

 -- Andreas Tille <tille@debian.org>  Fri, 10 Feb 2023 07:19:56 +0100
