=== debian/changelog ===
vienna-rna (2.6.4+dfsg-1build2) plucky; urgency=medium

  * No-change rebuild for Python 3.13 as the default.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 03 Jan 2025 14:43:03 +0100

vienna-rna (2.6.4+dfsg-1build1) oracular; urgency=medium

  * Rebuild against new libgsl28.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 30 Jul 2024 08:57:51 +0200

vienna-rna (2.6.4+dfsg-1) unstable; urgency=medium

  * Team upload
  * New upstream version 2.6.4+dfsg (Closes: #1074158)
  * Refreshing patches
  * Updating d/copyright
  * Updating the list of files to remove when repacking
  * Building with --no-parallel to avoid some problems with missing files
    during the build
  * Building against swig/4.2.0
  * Invoking python3 instead of python
  * Correcting install paths for the python3 binary package

 -- Pierre Gruet <pgt@debian.org>  Fri, 26 Jul 2024 10:18:54 +0200
