=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: vienna-rna
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Olivier Sallou <osallou@debian.org>,
            Steffen Moeller <moeller@debian.org>
 Section: non-free/science
