## vienna-rna 2.7.0%2Bdfsg

=== debian/changelog ===
vienna-rna (2.7.0+dfsg-1build1) resolute; urgency=medium

  * No-change rebuild for libdlib20.0.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Thu, 08 Jan 2026 09:35:42 +0000

vienna-rna (2.7.0+dfsg-1) unstable; urgency=medium

  * Team upload
  * New upstream version 2.7.0+dfsg
  * Refreshing patches
  * Raising Standards version to 4.7.2 (no change)
  * Updating the list of files to remove when repacking
  * Adding perl-xs-dev to Build-Depends (Closes: #1102852)
  * Building with gcc-15 (Closes: #1114434)
  * Adding missing inclusion of parent directory to find headers

 -- Pierre Gruet <pgt@debian.org>  Sat, 20 Sep 2025 22:59:19 +0200
